import 'package:flutter/material.dart';

class TLOperatorCardStyle {
  const TLOperatorCardStyle({
    this.showLalelImage = true,
    this.isRequire = false,
    this.titleStyle,
    this.subTitleStyle,
    this.titleTextMaxLines = 2,
    this.showLeading = false,
    this.showTrailing = false,
    this.trailingIcon,
    this.trailingIconData,
    this.trailingIconColor = const Color(0xFFC8C9CC),
    this.showLabelContent = false,
    this.showDivider = true,
    this.dividerColor = const Color(0xFFF7F8FA),
    this.showContent = true,
  });

  /// 是否显示标签图片，默认显示
  final bool showLalelImage;

  /// 是否显示必填 * 符号，默认非必需项
  final bool isRequire;

  /// 左Builder中文本title TextStyle
  final TextStyle? titleStyle;

  /// 左Builder中文本subTitle TextStyle
  final TextStyle? subTitleStyle;

  /// 左Builder中文本text显示行数，默认2行
  final int titleTextMaxLines;

  /// 是否显示左Builder，默认隐藏
  final bool showLeading;

  /// 是否显示右Builder，默认隐藏
  final bool showTrailing;

  /// 右Builder Icon
  final Icon? trailingIcon;

  /// 右Builder IconData
  final IconData? trailingIconData;

  /// 右Builder IconColor 默认: const Color(0xFFC8C9CC)
  final Color trailingIconColor;

  /// 是否显示下划线上面的Builder，默认隐藏
  final bool showLabelContent;

  /// 是否显示下划线，默认显示
  final bool showDivider;

  /// 下划线颜色 默认: const Color(0xFFF7F8FA)
  final Color dividerColor;

  /// 是否显示下划线下面的Builder，默认显示
  final bool showContent;
}
