import 'dart:math';

class TLChartMaxAndInterval {
  late num maxY;
  late num interval;

  TLChartMaxAndInterval() {
    maxY = 1;
    interval = 1;
  }
}

class TLChartCalculateUtils {
  static TLChartMaxAndInterval calculateChart<T>(List<T> statics, num Function(T item) condition, num minMaxY, num minInterval, {int factor = 1}) {
    //
    TLChartMaxAndInterval ret = TLChartMaxAndInterval();

    for (T item in statics) {
      num value = condition(item);
      if (value > ret.maxY) {
        ret.maxY = value;
      }
    }

    int count = (minMaxY / minInterval).ceil();

    ret.maxY = max(ret.maxY, minMaxY);

    ret.interval = (ret.maxY / count);

    ret.interval = roundUp(ret.interval.ceil(), factor);

    ret.maxY = ret.interval * count;

    return ret;
  }

  static int roundUp(int number, int factor) {
    if (factor < 1) throw RangeError.range(factor, 1, null, "factor");
    number += factor - 1;
    return number - (number % factor);
  }
}
