// ignore_for_file: unnecessary_this

import 'package:flutter/material.dart';


class TLine extends StatelessWidget {

  final Color? color;

  /// 分割线的或者分割条的高度 默认0.5
  final double height;

  /// 左边缩进距离
  final double leftInset;

  /// 右边缩进距离
  final double rightInset;

  const TLine({
    Key? key,
    this.color,
    this.height = 0.5,
    this.leftInset = 0,
    this.rightInset = 0,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: EdgeInsets.only(left: this.leftInset, right: this.rightInset),
      child: Divider(
        thickness: this.height,
        height: this.height,
        color: this.color ?? const Color(0xFFF0F0F0),
      ),
    );
  }
}
