import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

class TLListItemStyle {
  const TLListItemStyle({
    this.isRequire = false,
    this.showLeading = true,
    this.leadingTextMaxLines = 2,
    this.contentHintText = "请输入",
    this.inputFormatters,
    this.maxLength,
    this.enabled,
    this.keyboardType = TextInputType.text,
    this.showTrailing = false,
    this.trailingIcon,
    this.trailingIconData,
    this.trailingIconColor = const Color(0xFFC8C9CC),
    this.showDivider = true,
    this.dividerColor = const Color(0xFFF7F8FA),
  });

  /// 是否显示必填 * 符号 默认隐藏
  final bool isRequire;

  /// 是否显示左Builder
  final bool showLeading;

  /// 左Builder中文本text显示行数，默认2行
  final int leadingTextMaxLines;

  /// 在输入框内的提示文字
  final String? contentHintText;

  /// 用于指定输入格式；当用户输入内容改变时，会根据指定的格式来校验。
  final List<TextInputFormatter>? inputFormatters;

  /// 文本长度格式限制
  final int? maxLength;

  /// 输入框是否禁用；如果为false，则输入框会被禁用，禁用状态不接收输入和手势事件，同时显示禁用态样式（在其decoration中定义）。
  final bool? enabled;

  /// 键盘模式
  final TextInputType? keyboardType;

  /// 是否显示右Builder，默认隐藏
  final bool showTrailing;

  /// 右Builder Icon
  final Icon? trailingIcon;

  /// 右Builder IconData
  final IconData? trailingIconData;

  /// 右Builder IconColor 默认: const Color(0xFFC8C9CC)
  final Color trailingIconColor;

  /// 是否显示下划线
  final bool showDivider;

  /// 下划线颜色 默认: const Color(0xFFF7F8FA)
  final Color dividerColor;
}
