class TLProgressStatus {
  final bool isLoading;
  final bool isError;
  final bool isSuccess;
  final bool isEmpty;
  final bool isLoadingMore;
  final String? errorMessage;

  TLProgressStatus._({
    this.isEmpty = false,
    this.isLoading = false,
    this.isError = false,
    this.isSuccess = false,
    this.errorMessage,
    this.isLoadingMore = false,
  });

  factory TLProgressStatus.loading() {
    return TLProgressStatus._(isLoading: true);
  }

  factory TLProgressStatus.loadingMore() {
    return TLProgressStatus._(isSuccess: true, isLoadingMore: true);
  }

  factory TLProgressStatus.success() {
    return TLProgressStatus._(isSuccess: true);
  }

  factory TLProgressStatus.error([String? message]) {
    return TLProgressStatus._(isError: true, errorMessage: message);
  }

  factory TLProgressStatus.empty() {
    return TLProgressStatus._(isEmpty: true);
  }
}