import 'package:flutter/material.dart';

/// 筛选项 配置类
class TSelectionConfig {
  /// 遵循外部主题配置
  /// 默认为 [BrnDefaultConfigUtils.defaultSelectionConfig]
  TSelectionConfig({
    TextStyle? menuNormalTextStyle,
    TextStyle? menuSelectedTextStyle,
    TextStyle? tagNormalTextStyle,
    TextStyle? tagSelectedTextStyle,
    double? tagRadius,
    Color? tagNormalBackgroundColor,
    Color? tagSelectedBackgroundColor,
    TextStyle? hintTextStyle,
    TextStyle? rangeTitleTextStyle,
    TextStyle? inputTextStyle,
    TextStyle? itemNormalTextStyle,
    TextStyle? itemSelectedTextStyle,
    TextStyle? itemBoldTextStyle,
    Color? deepNormalBgColor,
    Color? deepSelectBgColor,
    Color? middleNormalBgColor,
    Color? middleSelectBgColor,
    Color? lightNormalBgColor,
    Color? lightSelectBgColor,
    TextStyle? resetTextStyle,
    TextStyle? titleForMoreTextStyle,
    TextStyle? optionTextStyle,
    TextStyle? moreTextStyle,
    TextStyle? flayerNormalTextStyle,
    TextStyle? flayerSelectedTextStyle,
    TextStyle? flayerBoldTextStyle,
  })  : _menuNormalTextStyle = menuNormalTextStyle,
        _menuSelectedTextStyle = menuSelectedTextStyle,
        _tagNormalTextStyle = tagNormalTextStyle,
        _tagSelectedTextStyle = tagSelectedTextStyle,
        _tagRadius = tagRadius,
        _tagNormalBackgroundColor = tagNormalBackgroundColor,
        _tagSelectedBackgroundColor = tagSelectedBackgroundColor,
        _hintTextStyle = hintTextStyle,
        _rangeTitleTextStyle = rangeTitleTextStyle,
        _inputTextStyle = inputTextStyle,
        _itemNormalTextStyle = itemNormalTextStyle,
        _itemSelectedTextStyle = itemSelectedTextStyle,
        _itemBoldTextStyle = itemBoldTextStyle,
        _deepNormalBgColor = deepNormalBgColor,
        _deepSelectBgColor = deepSelectBgColor,
        _middleNormalBgColor = middleNormalBgColor,
        _middleSelectBgColor = middleSelectBgColor,
        _lightNormalBgColor = lightNormalBgColor,
        _lightSelectBgColor = lightSelectBgColor,
        _resetTextStyle = resetTextStyle,
        _titleForMoreTextStyle = titleForMoreTextStyle,
        _optionTextStyle = optionTextStyle,
        _moreTextStyle = moreTextStyle,
        _flayerNormalTextStyle = flayerNormalTextStyle,
        _flayerSelectedTextStyle = flayerSelectedTextStyle,
        _flayerBoldTextStyle = flayerBoldTextStyle;

  /// menu 正常文本样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.colorTextBase],
  ///   fontSize: [BrnCommonConfig.fontSizeBase],
  ///   fontWeight: FontWeight.normal,
  /// )
  final TextStyle? _menuNormalTextStyle;

  /// menu 选中文本样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.brandPrimary],
  ///   fontSize: [BrnCommonConfig.fontSizeBase],
  ///   fontWeight: FontWeight.w600,
  /// )
  final TextStyle? _menuSelectedTextStyle;

  /// tag 正常文本样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.colorTextBase],
  ///   fontSize: [BrnCommonConfig.fontSizeCaption],
  ///   fontWeight: FontWeight.w400,
  /// )
  final TextStyle? _tagNormalTextStyle;

  /// tag 选中文本样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.brandPrimary],
  ///   fontSize: [BrnCommonConfig.fontSizeCaption],
  ///   fontWeight: FontWeight.w600,
  /// )
  final TextStyle? _tagSelectedTextStyle;

  /// tag 圆角
  /// 默认为 [BrnCommonConfig.radiusSm]
  final double? _tagRadius;

  /// tag 正常背景色
  /// 默认为 [BrnCommonConfig.fillBody]
  final Color? _tagNormalBackgroundColor;

  /// tag 选中背景色
  /// 默认为 [BrnCommonConfig.brandPrimary].withOpacity(0.12)
  final Color? _tagSelectedBackgroundColor;

  /// 输入选项标题文本样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.colorTextBase],
  ///   fontSize: [BrnCommonConfig.fontSizeSubHead],
  ///   fontWeight: FontWeight.w600,
  /// )
  final TextStyle? _rangeTitleTextStyle;

  /// 输入提示文本样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.colorTextHint],
  ///   fontSize: [BrnCommonConfig.fontSizeBase],
  /// )
  final TextStyle? _hintTextStyle;

  /// 输入框默认文本样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.colorTextBase],
  ///   fontSize: [BrnCommonConfig.fontSizeBase],
  /// )
  final TextStyle? _inputTextStyle;

  /// item 正常字体样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.colorTextBase],
  ///   fontSize: [BrnCommonConfig.fontSizeBase],
  /// )
  final TextStyle? _itemNormalTextStyle;

  /// item 选中文本样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.brandPrimary],
  ///   fontSize: [BrnCommonConfig.fontSizeBase],
  ///   fontWeight: FontWeight.w600,
  /// )
  final TextStyle? _itemSelectedTextStyle;

  /// item 仅加粗样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.colorTextBase],
  ///   fontSize: [BrnCommonConfig.fontSizeBase],
  ///   fontWeight: FontWeight.w600,
  /// )
  final TextStyle? _itemBoldTextStyle;

  /// 三级 item 背景色
  /// 默认为 Color(0xFFF0F0F0)
  final Color? _deepNormalBgColor;

  /// 三级 item 选中背景色
  /// 默认为 Color(0xFFF8F8F8)
  final Color? _deepSelectBgColor;

  /// 二级 item 背景色
  /// 默认为 Color(0xFFF8F8F8)
  final Color? _middleNormalBgColor;

  /// 二级 item 选中背景色
  /// 默认为 Colors.white
  final Color? _middleSelectBgColor;

  /// 一级 item 背景色
  /// 默认为 Colors.white
  final Color? _lightNormalBgColor;

  /// 一级 item 选中背景色
  /// 默认为 Colors.white
  final Color? _lightSelectBgColor;

  /// 重置按钮颜色
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.colorTextImportant],
  ///   fontSize: [BrnCommonConfig.fontSizeCaption]
  /// )
  final TextStyle? _resetTextStyle;

  /// 更多筛选-标题文本样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.colorTextBase],
  ///   fontSize: [BrnCommonConfig.fontSizeBase],
  ///   fontWeight: FontWeight.w600,
  /// )
  final TextStyle? _titleForMoreTextStyle;

  /// 选项-显示文本
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.brandPrimary],
  ///   fontSize: [BrnCommonConfig.fontSizeBase],
  /// )
  final TextStyle? _optionTextStyle;

  /// 更多文本样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.colorTextSecondary],
  ///   fontSize: [BrnCommonConfig.fontSizeCaption],
  /// )
  final TextStyle? _moreTextStyle;

  /// 跳转二级页-正常文本样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.colorTextBase],
  ///   fontSize: [BrnCommonConfig.fontSizeSubHead],
  ///   fontWeight: FontWeight.normal,
  /// )
  final TextStyle? _flayerNormalTextStyle;

  /// 跳转二级页-选中文本样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.brandPrimary],
  ///   fontSize: [BrnCommonConfig.fontSizeSubHead],
  ///   fontWeight: FontWeight.w600,
  /// )
  final TextStyle? _flayerSelectedTextStyle;

  /// 跳转二级页-加粗文本样式
  ///
  /// TextStyle(
  ///   color: [BrnCommonConfig.colorTextBase],
  ///   fontSize: [BrnCommonConfig.fontSizeSubHead],
  ///   fontWeight: FontWeight.w600
  /// )
  final TextStyle? _flayerBoldTextStyle;

  TextStyle get menuNormalTextStyle =>
      _menuNormalTextStyle ??
      const TextStyle(color:  Color(0xFF222222), fontSize: 14.0);

  TextStyle get menuSelectedTextStyle =>
      _menuSelectedTextStyle ??
      const TextStyle(color:  Color(0xFF0984F9), fontSize: 14.0, fontWeight: FontWeight.w600);

  TextStyle get tagNormalTextStyle =>
      _tagNormalTextStyle ??
      const TextStyle(color:  Color(0xFF222222), fontSize: 12.0);

  TextStyle get tagSelectedTextStyle =>
      _tagSelectedTextStyle ??
      const TextStyle(color:  Color(0xFF0984F9), fontSize: 12.0, fontWeight: FontWeight.w600);

  double get tagRadius =>
      _tagRadius ?? 4.0;

  Color get tagNormalBackgroundColor =>
      _tagNormalBackgroundColor ??
      const Color(0xFFF8F8F8);

  Color get tagSelectedBackgroundColor =>
      _tagSelectedBackgroundColor ??
      const Color(0xFF0984F9).withOpacity(0.12);

  TextStyle get rangeTitleTextStyle =>
      _rangeTitleTextStyle ??
      const TextStyle(color:  Color(0xFF222222), fontSize: 16.0, fontWeight: FontWeight.w600);

  TextStyle get hintTextStyle =>
      _hintTextStyle ??
      const TextStyle(color:  Color(0xFFCCCCCC), fontSize: 14.0);

  TextStyle get inputTextStyle =>
      _inputTextStyle ??
      const TextStyle(color:  Color(0xFF222222), fontSize: 14.0);

  TextStyle get itemNormalTextStyle =>
      _itemNormalTextStyle ??
      const TextStyle(color:  Color(0xFF222222), fontSize: 14.0);

  TextStyle get itemSelectedTextStyle =>
      _itemSelectedTextStyle ??
      const TextStyle(color:  Color(0xFF0984F9), fontSize: 14.0, fontWeight: FontWeight.w600);

  TextStyle get itemBoldTextStyle =>
      _itemBoldTextStyle ??
      const TextStyle(color:  Color(0xFF222222), fontSize: 14.0, fontWeight: FontWeight.w600);

  Color get deepNormalBgColor =>
      _deepNormalBgColor ??
      const Color(0xFFF0F0F0);

  Color get deepSelectBgColor =>
      _deepSelectBgColor ??
      const Color(0xFFF8F8F8);

  Color get middleNormalBgColor =>
      _middleNormalBgColor ??
      const Color(0xFFF8F8F8);

  Color get middleSelectBgColor =>
      _middleSelectBgColor ??
      Colors.white;

  Color get lightNormalBgColor =>
      _lightNormalBgColor ??
      Colors.white;

  Color get lightSelectBgColor =>
      _lightSelectBgColor ??
      Colors.white;

  TextStyle get resetTextStyle =>
      _resetTextStyle ??
      const TextStyle(
      color: Color(0xFF666666),
      fontSize: 12.0,
    );

  TextStyle get titleForMoreTextStyle =>
      _titleForMoreTextStyle ??
      const TextStyle(
      color: Color(0xFF222222),
      fontSize: 14.0,
      fontWeight: FontWeight.w600,
    );

  TextStyle get optionTextStyle =>
      _optionTextStyle ??
      const TextStyle(
      color: Color(0xFF0984F9),
      fontSize: 14.0,
    );

  TextStyle get moreTextStyle =>
      _moreTextStyle ??
      const TextStyle(
      color: Color(0xFF999999),
      fontSize: 12.0,
    );

  TextStyle get flayerNormalTextStyle =>
      _flayerNormalTextStyle ??
      const TextStyle(
      color: Color(0xFF222222),
      fontSize: 16.0,
    );

  TextStyle get flayerSelectedTextStyle =>
      _flayerSelectedTextStyle ??
      const TextStyle(
      color: Color(0xFF0984F9),
      fontSize: 16.0,
      fontWeight: FontWeight.w600,
    );

  TextStyle get flayerBoldTextStyle =>
      _flayerBoldTextStyle ??
      const TextStyle(
      color: Color(0xFF222222),
      fontSize: 16.0,
      fontWeight: FontWeight.w600,
    );
}
