import 'package:flutter/material.dart';
import 'package:tengits_widgets/tengits_widgets.dart';

class TLCardTextFieldStyle {
  const TLCardTextFieldStyle({
    this.color = const Color(0xFFF7F8FA),
    this.shadowColor = Colors.transparent,
    this.elevation = 0.0,
    this.shape,
    this.radius,
    this.margin = EdgeInsets.zero,
    this.clipBehavior = Clip.hardEdge,
    this.inputMaxLength,
    this.minHeight,
    this.maxHeight,
    this.hintDisabledText,
    this.textFieldStyle,
  });

  /// TLCardTextField 背景填充颜色 默认值 Color(0xFFF7F8FA)
  final Color color;

  /// TLCardTextField 阴影颜色 默认值 Colors.transparent
  final Color shadowColor;

  /// TLCardTextField 阴影高度 默认值 0.0
  final double elevation;

  /// TLCardTextField 边框 shape属性设置优先级高于radius属性设置
  final ShapeBorder? shape;

  /// TLCardTextField 圆角弧度
  final double? radius;

  /// TLCardTextField 外边距 默认值 EdgeInsets.zero
  final EdgeInsetsGeometry margin;

  /// TLCardTextField 剪切模式 默认值 Clip.hardEdge
  final Clip clipBehavior;

  /// TLCardTextField TLTextField 格式化文本长度
  final int? inputMaxLength;

  /// TLCardTextField TLTextField 最小高度约束
  final double? minHeight;

  /// TLCardTextField TLTextField 最大高度约束
  final double? maxHeight;

  /// TLCardTextField disable不可交互模式 在输入框内的提示文字
  final String? hintDisabledText;

  /// TLCardTextField TLTextField 风格
  final TLTextFieldStyle? textFieldStyle;
}
