import 'package:flutter/material.dart';

class ImageUtils {
  ///
  static ImageProvider getAssetImageProvider(String name, {AssetBundle? bundle, String? package}) {
    return AssetImage(getImagePath(name), bundle: bundle, package: package);
  }

  ///
  static String getImagePath(String name) {
    if (name.startsWith("assets")) {
      return name;
    }
    return 'assets/images/$name';
  }

  static Image getAssetImageWithColor(String assetFilePath, Color? color) {
    if (!assetFilePath.startsWith('assets')) {
      assetFilePath = 'assets/$assetFilePath';
    }
    return Image.asset(
      assetFilePath,
      color: color,
      package: "tengits_widgets",
      scale: 3.0,
    );
  }

  static Image getAssetImage(
    String assetFilePath, {
    BoxFit? fit,
    bool gaplessPlayback = false,
  }) {
    if (!assetFilePath.startsWith('assets')) {
      assetFilePath = 'assets/$assetFilePath';
    }
    return Image.asset(
      assetFilePath,
      package: "tengits_widgets",
      fit: fit,
      scale: 3.0,
      gaplessPlayback: gaplessPlayback,
    );
  }
}
